// MB15U36_PLL.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include <stdio.h>

#include "ntport.h"

unsigned int   PRTADDRESS;
#define WAITTIME   255

#define PRTADDRESS1 0x3bc
#define PRTADDRESS2 0x378
#define STATUS         PRTADDRESS+1
#define CONTROL        PRTADDRESS+2

int     band;     /* 1 - 14                                   */
double  IF1;      /* 380.75 MHz or 265.55 MHz                 */
double  IF2;      /* 10.8 MHz                                 */
double  step;     /* 5KHz,6.25KHz,10KHz,12.5KHz,50KHz,100KHz  */
double  f_step;
double  f, fm, fs;
int     set;      /* 1: 5 KHz  2: 12.5 KHz  3: 8.33 KHz 4: 6.25 KHz -- 2nd PLL REF */
int        N_1st, A_1st;
int        N_2nd, A_2nd;
int            data_count;
unsigned char  data[23];
unsigned char  LD1 = 1, LD2 = 0; /* Lock detect -- 1st LO select */
unsigned char  PSW = 0;          /* print off                    */
unsigned char  t_flag = 1;       /* fmin/fmax select             */
unsigned char  vco_test = 0;     /* test mode select             */
unsigned char  port_test = 0;    /* port test                    */

/* shif reg data table */
unsigned char  reg[11][12] =
/*      25-54 54-108 108-137 137-174 806-960 320-512 IF  VCO1 VCO2 /FMB  AM   NC                                            */
/*  bit   0     1       2       3       4       5     6    7    8    9   10   11                                            */
{       { 0,    1,      1,      1,      1,      1,    0,   1,   0,   1,   1,  1 },  /*  25.0000 -  27.9950 MHz  AM    5 KHz */
        { 0,    1,      1,      1,      1,      1,    0,   1,   0,   1,   0,  1 },  /*  28.0000 -  54.0000 MHz  FM    5 KHz */
        { 1,    0,      1,      1,      1,      1,    0,   1,   0,   1,   0,  1 },  /*  54.0000 -  87.2950 MHz  FM    5 KHz */
        { 1,    0,      1,      1,      1,      1,    0,   1,   0,   0,   0,  1 },  /*  87.3000 - 107.9000 MHz  WFM 100 KHz */
        { 1,    1,      0,      1,      1,      1,    0,   1,   0,   1,   1,  1 },  /* 108.0000 - 136.9875 MHz  AM  12.5KHz */
        { 1,    1,      1,      0,      1,      1,    0,   1,   0,   1,   0,  1 },  /* 137.0000 - 174.0000 MHz  FM    5 KHz */
        { 1,    1,      1,      1,      1,      0,    1,   0,   1,   1,   1,  1 },  /* 320.0000 - 400.0000 MHz  AM  6.25KHz */
		{ 1,    1,      1,      1,      1,      0,    1,   0,   1,   1,   0,  1 },  /* 400.0000 - 512.0000 MHz  FM  6.25KHz */
        { 1,    1,      1,      1,      0,      1,    0,   1,   0,   1,   0,  1 },  /* 806.0000 - 960.0000 MHz  FM  12.5KHz */
        { 1,    1,      1,      1,      1,      0,    1,   0,   1,   1,   0,  1 },  /* VCO2 test */
        { 1,    1,      1,      1,      1,      0,    1,   0,   1,   1,   0,  1 },  /* VCO4 test */

};

void wait(void);
void shift_reg_out(void);
void data_out(void);
void data_out_RF2_2(void);
void data_out_RF2_1(void);
void data_out_RF1_2(void);
void data_out_RF1_1(void);
void data_exe(void);
void data_setup(void);
void set_bank1(void);
void set_bank2(void);
void set_bank3(void);
void set_bank4(void);
void set_bank5(void);
void set_bank6(void);
void set_bank7(void);
void set_bank8(void);
void set_bank9(void);
void start_msg(void);
void MB15U36_pll(void);

void wait(void)
{
	volatile unsigned int i;
	volatile unsigned int j;
	volatile unsigned int k;

	for (i = 0; i < WAITTIME; i++)
	{
		for (j = 0; j < WAITTIME; j++)
		{
			k = i + j;
		}
	}
}

void shift_reg_out(void)
{
	/* printer port bit 4 - DATA : pin 6 - data4 */
	/*                  6 - CLK  : pin 1 - data6 */
	/*                  2 - LE2  : pin 7 - data2 */

	int      i;

	//Outport(PRTADDRESS, (WORD)0x00);
	Outport(PRTADDRESS, (WORD)0xFF); 
	wait();
	wait();
	if (PSW) printf(" Shift [11-0] : ");
	for (i = 0; i<12; i++)
	{
		if (PSW) printf("%d ", reg[band - 1][11 - i]);
		if (reg[band - 1][11 - i] == 1)
		{
			//Outport(PRTADDRESS, (WORD)0x10); /* data out */
			Outport(PRTADDRESS, (WORD)0xEF); /* data out */ //bit4=0
			wait();
			wait();
			//Outport(PRTADDRESS, (WORD)0x50); /* clk L->H */
			Outport(PRTADDRESS, (WORD)0xAF); /* clk L->H */ //bit6=0
			wait();
			wait();
		}
		else
		{
			//Outport(PRTADDRESS, (WORD)0x00); /* data out */
			Outport(PRTADDRESS, (WORD)0xFF); /* data out */ //bit4=1
			wait();
			wait();
			//Outport(PRTADDRESS, (WORD)0x40); /* clk L->H */
			Outport(PRTADDRESS, (WORD)0xBF); /* clk L->H */ //bit6=0
			wait();
			wait();
		}
	}
	//Outport(PRTADDRESS, (WORD)0x00);
	Outport(PRTADDRESS, (WORD)0xFF); /* data out */ //bit4=1
	wait();
	wait();
	//Outport(PRTADDRESS, (WORD)0x04); /* LE  L->H */
	Outport(PRTADDRESS, (WORD)0xFB); /* LE  L->H */ //bit2=0
	wait();
	wait();
	//Outport(PRTADDRESS, (WORD)0x00);
	Outport(PRTADDRESS, (WORD)0xFF); /* LE  H->L */ //bit2=1
	if (PSW) printf("\n");
}


void data_out(void)
{
	/* DB9F--DB25M
       GND--GND
        1 -- 8   data6
        2 -- 3   data1
        3 -- 2   data0
        4 -- 20  GND
        5 -- 7   data5
        6 -- 6   data4
        7 -- 4   data2
        8 -- 5   data3
        9 -- 22  GND
    */
	/* printer port bit 4 - DATA : pin 6 - data4 */
	/*                  6 - CLK  : pin 1 - data6 */
	/*                  3 - LE1  : pin 8 - data3 */
	int  i, j;

	j = data_count + 1;

	//Outport(PRTADDRESS, (WORD)0x00);
	Outport(PRTADDRESS, (WORD)0xFF); 
	wait();
	wait();
	for (i = 1; i<j; i++)
	{
		if (PSW) printf("%d ", data[j-i]);
		if (data[j-i] == 1)
		{
			//Outport(PRTADDRESS, (WORD)0x10); /* data out */
			Outport(PRTADDRESS, (WORD)0xEF); /* data out */ //bit4=0
			wait();
			wait();
			//Outport(PRTADDRESS, (WORD)0x50); /* clk L->H */
			Outport(PRTADDRESS, (WORD)0xAF); /* clk L->H */ //bit6=0
			wait();
			wait();
		}
		else
		{
			//Outport(PRTADDRESS, (WORD)0x00); /* data out */
			Outport(PRTADDRESS, (WORD)0xFF); /* data out */ //bit4=1
			wait();
			wait();
			//Outport(PRTADDRESS, (WORD)0x40); /* clk L->H */
			Outport(PRTADDRESS, (WORD)0xBF); /* clk L->H */ //bit6=0
			wait();
			wait();
		}
	}
	//Outport(PRTADDRESS, (WORD)0x00);
	Outport(PRTADDRESS, (WORD)0xFF); /* data out */ //bit4=1
	wait();
	wait();
	//Outport(PRTADDRESS, (WORD)0x08); /* LE  L->H */
	Outport(PRTADDRESS, (WORD)0xF7); /* LE  L->H */ //bit3=0
	wait();
	wait();
	//Outport(PRTADDRESS, (WORD)0x00);
	Outport(PRTADDRESS, (WORD)0xFF); /* LE  H->L */ //bit3=1
	if (PSW) printf("\n");
}

void data_out_RF2_2(void)
{
	int            i, temp;

	/* RF2 -- Programmable Counter/Swallow Counter  */
	/* bit 22   PS       0 : Power saving off       */
	/*     21   SW       1 : P = 128                */
	/*  10-20   N[1:10]  N counter (N_2st)          */
	/*   3- 9   A[1:7]   A counter (A_2st)          */
	/*      2   CN2      0 : RF2                    */
	/*      1   CN1      1 : RF2                    */

	/* bit 22-1 = 01 [N_2st] [A_2st] 11   */

	data[22] = 0;
	data[21] = 1;

	temp = N_2nd;
	for (i = 10; i<21; i++)
	{
		data[i] = (temp % 2);
		temp /= 2;
	}
	temp = A_2nd;
	for (i = 3; i<10; i++)
	{
		data[i] = (temp % 2);
		temp /= 2;
	}
	data[2] = 0;
	data[1] = 1;

	if (PSW) printf(" RF2_2 [21-0] : ");
	data_count = 22;
	data_out();
}

void data_out_RF2_1(void)
{
	/* RF2 -- Programmable Reference Counter        */
	/* bit 22   FDS      0 : fout off (only used)   */
	/*     21   LDS      0 : LD off   (only used)   */
	/*     20   ZC       0 : normal                 */
	/*     19   CMC      1 : x4                     */
	/*     18   FC       1 : non-invert polarity    */
	/*   3-17   R[1:15]  2070 = 000 1000 0001 0110  */
	/*                or  828 = 000 0011 0011 1100  */
	/*                or 1656 = 000 0110 0111 1000  */
	/*      2   CN2      0 : RF2                    */
	/*      1   CN1      0 : RF2                    */

	/* bit 22-1 = 00 0110 : 0010 0000 : 0101 1000   */
	/*       or = 00 0110 : 0000 1100 : 1111 0000   */
	/*       or = 00 0110 : 0001 1001 : 1110 0000   */

	int     i, temp;

	data[22] = 0;
	data[21] = LD2 ? 1 : 0;
	data[20] = 0;
	data[19] = 1;
	data[18] = 1;

	if (set == 1)
		temp = 2070;
	else if (set == 3)
		temp = 1242;
	else
		temp = 1656;
	for (i = 3; i<18; i++)
	{
		data[i] = (temp % 2);
		temp /= 2;
	}
	data[2] = 0;
	data[1] = 0;

	if (PSW) printf(" RF2_1 [21-0] : ");
	data_count = 22;
	data_out();
}

void data_out_RF1_2(void)
{
	int            i, temp;

	/* RF1 -- Programmable Counter/Swallow Counter  */
	/* bit 22   PS       0 : Power saving off       */
	/*     21   SW       0 : P = 64                 */
	/*  10-20   N[1:10]  N counter (N_1st)          */
	/*   3- 9   A[1:7]   A counter (A_1st)          */
	/*      2   CN2      1 : RF1                    */
	/*      1   CN1      1 : RF1                    */

	/* bit 22-1 = 00 [N_1st] [A_1st] 11   */

	data[22] = 0;
	data[21] = 0;

	temp = N_1st;
	for (i = 10; i<21; i++)
	{
		data[i] = (temp % 2);
		temp /= 2;
	}
	temp = A_1st;
	for (i = 3; i<10; i++)
	{
		data[i] = (temp % 2);
		temp /= 2;
	}
	data[2] = 1;
	data[1] = 1;

	if (PSW) printf(" RF1_2 [21-0] : ");
	data_count = 22;
	data_out();
}

void data_out_RF1_1(void)
{
	/* RF1 -- Programmable Reference Counter        */
	/* bit 22   FDS      0 : fout off (only used)   */
	/*     21   LDS      0 : LD off   (only used)   */
	/*     20   ZC       0 : normal                 */
	/*     19   CMC      0 : x1                     */
	/*     18   FC       0 : invert polarity        */
	/*   3-17   R[1:15]  207 = 000 0000 1100 1111   */
	/*      2   CN2      1 : RF1                    */
	/*      1   CN1      0 : RF1                    */

	/* bit 22-1 = 00 0000 : 0000 0011 : 0011 1110   */

	data[22] = 0;
	data[21] = LD1 ? 1 : 0;
	data[20] = 0;
	data[19] = 0;
	data[18] = 0;
	data[17] = 0;
	data[16] = 0;
	data[15] = 0;
	data[14] = 0;
	data[13] = 0;
	data[12] = 0;
	data[11] = 0;
	data[10] = 1;
	data[9] = 1;
	data[8] = 0;
	data[7] = 0;
	data[6] = 1;
	data[5] = 1;
	data[4] = 1;
	data[3] = 1;
	data[2] = 1;
	data[1] = 0;

	if (PSW) printf(" RF1_1 [21-0] : ");
	data_count = 22;
	data_out();
}

void data_exe(void)
{
	/* PLL -- MB15U36                                  */
	/* fVCO = {(P x N) + A} x fOSC / R  (A < N)        */
	/* P : 64 or 128                                   */
	/* N : 3 to 2047                                   */
	/* A : 0 to 127                                    */
	/* R : 3 to 32767                                  */
	/*                                                 */
	/* fOSC = 10.35 MHz                                */
	/* 1st LO step = 50 KHz   -> R = 10350/50   = 207  */
	/* 2nd LO step = 5  KHz   -> R = 10350/5    = 2070 */
	/*          or = 12.5 KHz -> R = 10350/12.5 = 828  */
	/*          or = 8.33 KHz -> R = 10350/8.33 = 1242 */
	/*          or = 6.25 KHz -> R = 10350/6.25 = 1656 */
	/* 1st IF = 308.75 MHz                             */
	/*     or = 265.55 MHz                             */
	/* 2nd IF = 10.8  MHz                              */

	double     LO_1st;
	double     PN_A_1st, PN_A_2nd;

	/* 1st LO PLL -- 100 KHz step */
	/* 1st PN+A   -- 50  KHz step */
	/* 2nd PN+A   -- 5 KHz or 12.5 KHz or 8.33 KHz or 6.25 KHz step */

	/* 100KHz step */
	LO_1st = 2 * (double)((int)((f + 0.1) / 100000));
	
	if (band == 9)
	{
		LO_1st -= IF1;
		PN_A_1st = LO_1st;
		if (set == 1)
			PN_A_2nd = f / step - (PN_A_1st + IF2) * 10;
		else if (set == 2)
			PN_A_2nd = f / step - (PN_A_1st + IF2) * 4;
		else if (set == 3)
			PN_A_2nd = f / step - (PN_A_1st + IF2) * 6;
		else
			PN_A_2nd = f / step - (PN_A_1st + IF2) * 8;
	}
	else
	{
		LO_1st += IF1;
		PN_A_1st = LO_1st;
		if (set == 1)
			PN_A_2nd = (PN_A_1st - IF2) * 10 - f / step;
		else if (set == 2)
			PN_A_2nd = (PN_A_1st - IF2) * 4 - f / step;
		else if (set == 3)
			PN_A_2nd = (PN_A_1st - IF2) * 6 - f / step;
		else
			PN_A_2nd = (PN_A_1st - IF2) * 8 - f / step;
	}

	if (vco_test)
	{
		if ((band == 1) || (band == 10))
		{
			LO_1st = f / 100000;
			PN_A_1st = LO_1st * 2;
		}
		if ((band == 3) || (band == 11))
			PN_A_2nd = f / step;
	}

	N_1st = (int)(PN_A_1st / 64);  /* 1st P = 64 */
	A_1st = (int)(PN_A_1st - 64 * N_1st);
	N_2nd = (int)(PN_A_2nd / 128); /* 2nd P = 128 */
	A_2nd = (int)(PN_A_2nd - 128 * N_2nd + 0.1);

	if (vco_test)
	{
		if ((band == 3) || (band == 11))
			printf(" 2nd LO (MHz) = %f      \n", PN_A_2nd*step / 1000000);
		else
			printf(" 1st LO (MHz) = %f      \n", LO_1st / 10);
	}
	else
	{
		printf(" %f :                                                     \n", f / 1000000);
		printf(" 1st LO (MHz) = %f  P =  64  N = %d  A = %d \n", LO_1st / 20, N_1st, A_1st);
		printf(" 2nd LO (MHz) = %f  P = 128  N = %d  A = %d \n", PN_A_2nd*step / 1000000, N_2nd, A_2nd);
	}
}

void data_setup(void)
{
	char key[10];

	fs = f;
	do
	{
		printf("\n");
		printf(" %f (RET or S,A,P,@,E)? ", f / 1000000);
		fgets(key, sizeof(key), stdin);
		printf("\n");
		if ((key[0] == 'P') || (key[0] == 'p')) /* Data Print SW */
		{
			printf("\n");
			if (PSW == 1)
				PSW = 0;
			else
				PSW = 1;
		}
		else if ((key[0] == 'S') || (key[0] == 's')) /* Freq data input */
		{
			printf("\n");
			printf(" ? MHz : ");
			fgets(key, sizeof(key), stdin);
			printf("\n");
			f = atof(key);
			f *= 1000000;
		}
		else if (key[0] == '@') /* fmin or fmax SW */
		{
			printf("\n");
			if (t_flag)
			{
				f = fm;
				t_flag = 0;
			}
			else
			{
				f = fs;
				t_flag = 1;
			}
		}
		else if ((key[0] == 'A') || (key[0] == 'a')) /* f_step input */
		{
			printf("\n");
			printf(" ? MHz STEP: ");
			fgets(key, sizeof(key), stdin);
			printf("\n");
			f_step = atof(key);
			f_step *= 1000000;
		}
		else if ((key[0] == 'E') || (key[0] == 'e')) /* end */
			break;
		else
		{
			data_exe();
			data_out_RF1_1();
			data_out_RF1_2();
			data_out_RF2_1();
			data_out_RF2_2();
			shift_reg_out();

			if (t_flag) f += f_step;
		}
	} while ((f<fm) || (f == fm));

	printf("\n");
}

void set_bank1(void)
{
	band = 1;
	if (vco_test) /* VCO 1 -- 370 - 610 MHz  10 MHz step  */
	{
		f = 370000000;
		fm = 610000000;
		f_step = 10000000;
	}
	else
	{
		f = 25000000;
		fm = 27995000;
		f_step = 5000;
	}
	step = 5000;
	set = 1;     /* 5 KHz    */
	IF1 = 7616;  /* 3808x2   */
	IF2 = 216;   /* 108x2    */
	data_setup();
}

void set_bank2(void)
{
	band = 2;
	if (vco_test) /* VCO 2 -- 550 - 800 MHz  10 MHz step  */
	{
		band = 10;
		f = 550000000;
		fm = 800000000;
		f_step = 10000000;
	}
	else
	{
		f = 28000000;
		fm = 53995000;
		f_step = 5000;
	}
	step = 5000;
	set = 1;     /* 5 KHz    */
	IF1 = 7616;  /* 3808x2   */
	IF2 = 216;   /* 108x2    */
	data_setup();
}

void set_bank3(void)
{
	band = 3;
	if (vco_test) /* VCO 3 -- 340 - 400 MHz  10 MHz step  */
	{
		f = 340000000;
		fm = 400000000;
		f_step = 10000000;
	}
	else
	{
		f = 54000000;
		fm = 87295000;
		f_step = 5000;
	}
	step = 5000;
	set = 1;     /* 5 KHz    */
	IF1 = 7616;  /* 3808x2   */
	IF2 = 216;   /* 108x2    */
	data_setup();
}

void set_bank4(void)
{
	band = 4;
	if (vco_test) /* VCO 4 -- 250 - 300 MHz  1 MHz step  */
	{
		band = 11;
		f = 250000000;
		fm = 300000000;
		f_step = 1000000;
	}
	else
	{
		f = 87300000;
		fm = 107900000;
		f_step = 100000;
	}
	step = 6250;
	set = 4;     /* 6.25 KHz */
	IF1 = 7616;  /* 3808x2   */
	IF2 = 216;   /* 108x2    */
	data_setup();

}

void set_bank5(void)
{
	band = 5;
	f = 108000000;
	fm = 136987500;
	f_step = 12500 / 1.5; // 8333.3333334;
	step = 12500 / 1.5; // 8333.3333334;
	set = 3;     /* 8.33 KHz */
	IF1 = 7616;  /* 3808x2   */
	IF2 = 216;   /* 108x2    */
	data_setup();
}

void set_bank6(void)
{
	band = 6;
	f = 137000000;
	fm = 174000000;
	f_step = 5000;
	step = 5000;
	set = 1;     /* 5 KHz    */
	IF1 = 7616;  /* 3808x2   */
	IF2 = 216;   /* 108x2    */
	data_setup();
}

void set_bank7(void)
{
	band = 7;
	f = 320000000;
	fm = 400000000;
	f_step = 12500;
	step = 6250;
	set = 4;     /* 6.25 KHz */
	IF1 = 5312;  /* 2656x2 */
	IF2 = 216;   /* 108x2    */
	data_setup();
}

void set_bank8(void)
{
	band = 8;
	f = 400000000;
	fm = 512000000;
	f_step = 12500;
	step = 6250;
	set = 4;     /* 6.25 KHz */
	IF1 = 5312;  /* 2656x2 */
	IF2 = 216;   /* 108x2    */
	data_setup();
}

void set_bank9(void)
{
	band = 9;
	f = 806000000;
	fm = 960000000;
	f_step = 12500;
	step = 6250;
	set = 4;     /* 6.25 KHz */
	IF1 = 7614;  /* 3807x2   */
	IF2 = 216;   /* 108x2    */
	data_setup();
}

void start_msg(void)
{
	printf(" MB15U36 PLL Data output program                                  \n");
	printf("                                                                  \n");
	printf(" Printer port : pin 6 = PLL_DATA                                  \n");
	printf("                pin 1 = PLL_CLK                                   \n");
	printf("                pin 8 = LE1 (PLL)                                 \n");
	printf("                pin 7 = LE2 (Shift Reg)                           \n");
	printf("                                                                  \n");
	printf("                                                  STEP(KHz)       \n");
	printf(" Band 1 -- AM    VLO1-1    25.000 -  27.995  MHz    5             \n");
	printf("      2 -- FM    VLO1-2    28.000 -  53.995  MHz    5             \n");
	printf("      3 -- FM    VLO2-1    54.000 -  87.295  MHz    5             \n");
	printf("      4 -- WFM   VLO2-2    87.300 - 107.900  MHz   100            \n");
	printf("      5 -- AM    AIR      108.000 - 136.9875 MHz   8.33           \n");
	printf("      6 -- FM    VHI1     137.000 - 174.000  MHz    5             \n");
	printf("      7 -- AM    UHF      320.000 - 400.000  MHz   6.25           \n");
	printf("      8 -- FM    UHF      400.000 - 512.000  MHz   6.25           \n");
	printf("      9 -- FM    800      806.000 - 960.000  MHz   12.5           \n");
	printf("      L -- Lock detect SW (default - 1st LO)                      \n");
	printf("      P -- Data print  SW (default - off)                         \n");
	printf("      Q -- VCO1.2.3.4 test                                        \n");
	if (vco_test)
		printf(" VCO ? ");
	else
		printf(" ? ");
}

void MB15U36_pll(void)
{
	char key[10];

	LD1 = 1;
	LD2 = 1;
	PSW = 0;
	t_flag = 1;
	vco_test = 0;

	for (;;)
	{
		t_flag = 1;
		start_msg();
		fgets(key, sizeof(key), stdin);
		printf("\n");

		if (key[0] == '1') /* Band 1 -- 25.0000 -  27.9950 MHz  AM  5 KHz step */
		{
			set_bank1();
		}
		else if (key[0] == '2') /* Band 2 -- 28.0000 -  54.0000 MHz  FM  5 KHz step */
		{
			set_bank2();
		}
		else if (key[0] == '3') /* Band 3 -- 54.0000 -  87.9950 MHz  FM  5 KH step */
		{
			set_bank3();
		}
		else if (key[0] == '4') /* Band 4 -- 88.0000 - 107.9000 MHz  WFM  100 KHz step */
		{
			set_bank4();
		}
		else if (key[0] == '5') /* Band 5 -- 108.0000 - 136.9875 MHz  AM  12.5KHz step */
		{
			set_bank5();
		}
		else if (key[0] == '6') /* Band 6 -- 137.0000 - 174.0000 MHz  FM  5 KHz step */
		{
			set_bank6();
		}
		else if (key[0] == '7') /* Band 7 -- 320.0000 - 400.0000 MHz  AM  6.25KHz step */
		{
			set_bank7();
		}
		else if (key[0] == '8') /* Band 8 -- 400.0000 - 512.0000 MHz  FM  6.25KHz step */
		{
			set_bank8();
		}
		else if (key[0] == '9') /* Band 9 -- 806.0000 - 960.0000 MHz  FM  12.5KHz step */
		{
			set_bank9();
		}
		else if ((key[0] == 'L') || (key[0] == 'l')) /* Lock detect SW */
		{
			if (LD1 == 0)
			{
				printf(" Lock detect -- 1st LO select \n");
				LD1 = 1;
				LD2 = 0;
			}
			else
			{
				printf(" Lock detect -- 2nd LO select \n");
				LD1 = 0;
				LD2 = 1;
			}
		}

		else if ((key[0] == 'P') || (key[0] == 'p')) /* Data Print SW */
		{
			if (PSW == 1)
				PSW = 0;
			else
				PSW = 1;
		}
		else if ((key[0] == 'Q') || (key[0] == 'q')) /* VCO test mode SW */
		{
			if (vco_test)
				vco_test = 0;
			else
				vco_test = 1;
		}
		else
			break;
		printf("\n\n");
	}
	printf("\n");

}

int _tmain(int argc, _TCHAR* argv[])
{
	int  key;
	unsigned char outNum;
	
	printf("\n");
	printf(" PRT Port Address (1 : 0x3bc  2 : 0x378) ? ");
	key = getchar();

	if (key == '1')
	{
		PRTADDRESS = PRTADDRESS1;
		printf(" Address : 0x3bc \n");
	}
	else
	{
		PRTADDRESS = PRTADDRESS2;
		printf(" Address : 0x378 \n");
	}
	getchar();

	printf("Ready ? \n");
	getchar();

	//port test1
	outNum = 0x00;
	//outNum = 0xff;
	outNum = ~outNum;
	Outport(PRTADDRESS, (WORD)outNum);
	//printf("out : 0x00 \n");
	printf("out : 0xff \n"); //invert
	getchar();

	//port test2
	//outNum = 0x00;
	outNum = 0xff;
	outNum = ~outNum;
	Outport(PRTADDRESS, (WORD)outNum);
	printf("out : 0x00 \n"); //invert
	//printf("out : 0xff \n");
	getchar();

	printf("Program start \n");
	printf("Ready ? \n"); // waits power on
	getchar();
	
	MB15U36_pll();

	printf("Program end \n");
	getchar();

	return 0;
}

